import Path from './Path';
var traverse = function (node, visitors) {
    // Create a path
    var path = new Path(node);
    // Entering node
    visitors.forEach(function (visitor) {
        var _a, _b;
        (_b = (_a = visitor[node.type]) === null || _a === void 0 ? void 0 : _a.enter) === null || _b === void 0 ? void 0 : _b.call(_a, path);
    });
    // Possible sub nodes
    switch (node.type) {
        case 'Array':
            node.elements.forEach(function (node) {
                traverse(node, visitors);
            });
            break;
        case 'Object':
            node.entries.forEach(function (node) {
                traverse(node, visitors);
            });
            break;
        case 'ObjectEntry':
            traverse(node.value, visitors);
    }
    // Exiting node
    visitors.forEach(function (visitor) {
        var _a, _b;
        (_b = (_a = visitor[node.type]) === null || _a === void 0 ? void 0 : _a.exit) === null || _b === void 0 ? void 0 : _b.call(_a, path);
    });
};
export default traverse;
