var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "object.fromentries"], factory);
    }
})(function (require, exports) {
    "use strict";
    exports.__esModule = true;
    var object_fromentries_1 = __importDefault(require("object.fromentries"));
    var generate = function (node) {
        switch (node.type) {
            case 'String':
                return node.value;
            case 'Number':
                return node.value;
            case 'Boolean':
                return node.value;
            case 'Null':
                return null;
            case 'Array':
                return node.elements.map(function (node) { return generate(node); });
            case 'Object':
                return object_fromentries_1["default"](node.entries.map(function (node) { return generate(node); }));
            case 'ObjectEntry':
                return [node.key, generate(node.value)];
        }
    };
    exports["default"] = generate;
});
